
#include <stdio.h>
#include "Queue.h"			//	ť ߰
#include "point.h"

#define		HEIGHT		7	//	δ   ( )
#define		WIDTH		7	//	δ   ( )

#define		TRUE		1
#define		FALSE		0

/*	δ  ǹϴ 2 迭	*/
static int g_Map[HEIGHT][WIDTH] = {
	0,1,1,0,1,0,0,
	0,1,1,0,1,0,1,
	1,1,1,0,1,0,1,
	0,0,0,0,1,1,1,
	0,1,0,0,0,0,0,
	0,1,1,1,1,1,0,
	0,1,1,1,0,0,0
};

/*	
	δ  ϳ ãƼ,     ãƳ Լ
	Ű 
		1. Ž δ (g_Map) 
		2. Ž δ (g_Map) 
		3. ãƳ   (δ  ش  )
*/
int SearchBFS(int row, int col, const int number);

/*	
	Ž  (   ƴ) δ    üũϱ  Լ
	Ž   δ  ζ 1 ϰ ׷  0 Ѵ.
*/
int IsInMap(int rowToMove, int colToMove);

/*	δ  ִ Լ	*/
void DisplayMap(void);

int main(void)
{
	int row, col;			//	Ž δ   
	int holeCnt = 0;		//	ãƳ ϳ   δ  
	int number = 1;			//	ãƳ δ  ο 
	int totalHoleCnt = 0;	//	ü δ  

	printf("δ  ʱ \n");
	DisplayMap();
	printf("\n\n");

	for ( row = 0; row < HEIGHT; row++)
	{
		for (col = 0; col < WIDTH; col++)
		{
			//	1 õ  δ  ִ ġ̴.
			if (g_Map[row][col] == 1)
			{
				number += 1;

				holeCnt = SearchBFS(row, col, number);

				totalHoleCnt += 1;
			}
		}
	}
	
	printf("δ   \n");
	DisplayMap();

	return 0;
}

/*
	δ  ϳ ãƼ,     ãƳ Լ
	Ű 
		1. Ž δ (g_Map) 
		2. Ž δ (g_Map) 
		3. ãƳ   (δ  ش  )
*/
int SearchBFS(int row, int col, const int number)
{
	int caveDepth = 0;			//	 ()

	point curPos = {row, col};	//	 ġ 
	
	point neighborPos;			//	 ġ   ġ

	Queue q;					//	ť 

	QueueInit(&q);				//	ť ʱȭ

	Push(&q, curPos);			//	ť  ġ 

	//	ش   1 number 
	g_Map[row][col] = number;

	//	ť (ġ )   ݺ
	while (QueueIsEmpty(&q) == NO)
	{
		curPos = Front(&q);	//	ť ġ  ϳ 
		Pop(&q);			//	ť ġ  

		int curRow = curPos.row;
		int curColumn = curPos.column;

		//	Ž   4̴. ,Ʒ,,.

		//	   Ʒ  Ž  ִ üũ
		if (IsInMap(curRow + 1, curColumn) && g_Map[curRow + 1][curColumn] == 1)
		{
			g_Map[curRow + 1][curColumn] = number;

			//	 ġ  ̿ ġ ť .
			neighborPos.row = curRow + 1;
			neighborPos.column = curColumn;
			
			Push(&q, neighborPos);

			caveDepth += 1;
		}

		//	     Ž  ִ üũ
		if (IsInMap(curRow - 1, curColumn) && g_Map[curRow - 1][curColumn] == 1)
		{
			g_Map[curRow - 1][curColumn] = number;

			//	 ġ  ̿ ġ ť .
			neighborPos.row = curRow - 1;
			neighborPos.column = curColumn;

			Push(&q, neighborPos);

			caveDepth += 1;
		}

		//	     Ž  ִ üũ
		if (IsInMap(curRow, curColumn + 1) && g_Map[curRow][curColumn + 1] == 1)
		{
			g_Map[curRow][curColumn + 1] = number;

			//	 ġ  ̿ ġ ť .
			neighborPos.row = curRow;
			neighborPos.column = curColumn + 1;

			Push(&q, neighborPos);

			caveDepth += 1;
		}

		//	     Ž  ִ üũ
		if (IsInMap(curRow, curColumn - 1) && g_Map[curRow][curColumn - 1] == 1)
		{
			g_Map[curRow][curColumn - 1] = number;

			//	 ġ  ̿ ġ ť .
			neighborPos.row = curRow;
			neighborPos.column = curColumn - 1;

			Push(&q, neighborPos);

			caveDepth += 1;
		}
	}
	return caveDepth;
}

/*
	Ž  (   ƴ) δ    üũϱ  Լ
	Ž   δ  ζ 1 ϰ ׷  0 Ѵ.
*/
int IsInMap(int rowToMove, int colToMove)
{
	if (rowToMove >= 0 && rowToMove <= HEIGHT - 1)
	{
		if (colToMove >= 0 && colToMove <= WIDTH - 1)
			return TRUE;
	}
	return FALSE;
}

/*	δ  ִ Լ	*/
void DisplayMap(void)
{
	int row, col;

	for ( row = 0; row < HEIGHT; row++)
	{
		for ( col = 0; col < WIDTH; col++)
			printf("%d ", g_Map[row][col]);
		
		printf("\n");
	}
}

